﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;

namespace _84826
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = GetData();
        }

        private DataSet GetData()
        {
            DataSet ds = new DataSet();

            DataTable dt = new DataTable();
            dt.Columns.Add("Company Name", typeof(string));
            dt.Columns.Add("Document No", typeof(string));
            dt.Columns.Add("Line No", typeof(int));
            dt.Columns.Add("Sales Product No", typeof(string));
            dt.Columns.Add("Sales Product Desc", typeof(string));
            dt.Columns.Add("Sales Price", typeof(decimal));
            dt.Columns.Add("Sales Qty", typeof(int));
            dt.Columns.Add("Sales UM", typeof(string));

            Random rnd = new Random();
            for (int i = 0; i < 15; i++)
            {
                decimal price = (decimal)rnd.Next( 1000, 10000) / 100;
                string salesStr = String.Format("Sales string {0}",i);
                int qty = rnd.Next(1,100);
                string name = string.Format("Company {0}",i);
                string doc = string.Format("Document {0}",i);
                dt.Rows.Add(name, doc, i, salesStr, salesStr, price, qty, salesStr);
            }

            ds.Tables.Add(dt);
            return ds;

        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {

            UltraGridColumn col = e.Layout.Bands[0].Columns.Add("product( [Sales Qty] , [Sales Price] )");
            col.DataType = typeof(decimal);
            col.Formula = "product( [Sales Qty] , [Sales Price] )";
            col.Format = "$#,##0.00";

            e.Layout.Bands[0].Summaries.Add("SUM ([Sales Line Total])");

            UltraGridColumn col1 = e.Layout.Bands[0].Columns.Add("[Sales Qty] * [Sales Price]");
            col1.DataType = typeof(decimal);
            col1.Formula = " [Sales Qty] * [Sales Price] ";
            col1.Format = "$#,##0.00";

            
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {

            ultraGridExcelExporter1.Export(ultraGrid1, "Test.xls");
            Process.Start("Test.xls");
        }

        private void ultraGridExcelExporter1_CellExported(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.CellExportedEventArgs e)
        {
            if (!string.IsNullOrEmpty(e.GridColumn.Format))
                e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].CellFormat.FormatString = e.GridColumn.Format;
        }

        private void ultraGridExcelExporter1_FormulaExporting(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.FormulaExportingEventArgs e)
        {
            
        }

        private void ultraGrid1_BeforeColumnChooserDisplayed(object sender, BeforeColumnChooserDisplayedEventArgs e)
        {
            
        }
    }
}
